diff --git a/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java b/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java
index 5f6db4c01..c8695b61d 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/TeleportCommand.java
@@ -1,138 +1,79 @@
 package net.minecraft.core.net.command.commands;
 
-import com.mojang.logging.LogUtils;
-import net.minecraft.core.Global;
-import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.server.entity.player.ServerPlayer;
-import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.net.command.PlayerCommandSender;
-import net.minecraft.core.net.command.ServerCommandHandler;
-import org.slf4j.Logger;
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.tree.CommandNode;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.arguments.Vec3ArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.DoubleCoordinates;
+import net.minecraft.core.net.command.helpers.EntitySelector;
 
-public class TeleportCommand extends Command{
-	private static final Logger LOGGER = LogUtils.getLogger();
-	public TeleportCommand() {
-		super("tp");
-	}
+import java.util.List;
 
-	@Override
-	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		LOGGER.info("TP Command");
-        LOGGER.info("handler: {}", handler);
-        LOGGER.info("sender: {}", sender);
-		
-		boolean sentByPlayer = sender instanceof PlayerCommandSender;
-		
-		if(args.length > 0) {
-			if(args.length <= 2) {
-				Player from = null;
-				Player to = null;
-				
-				if(args.length == 1) {
-					if(sentByPlayer) {
-						from = sender.getPlayer();
-						to = getPlayer(handler, args[0]);
-					}else {
-						return false;
-					}
-				}
-				if(args.length == 2) {
-					from = getPlayer(handler, args[0]);
-					to = getPlayer(handler, args[1]);
-				}
-				
-				teleport(handler, sender, from, to);
-				return true;
-			}
-			
-			Player player = null;
-			double x = 0.0;
-			double y = 0.0;
-			double z = 0.0;
-			
-			if(args.length == 3 && sentByPlayer) {
-				x = parseDouble(args[0]);
-				y = parseDouble(args[1]);
-				z = parseDouble(args[2]);
-				player = sender.getPlayer();
-			}
-			
-			if(args.length == 4) {
-				player = getPlayer(handler, args[0]);
-				x = parseDouble(args[1]);
-				y = parseDouble(args[2]);
-				z = parseDouble(args[3]);
-			}
-			x = MathHelper.clamp(x, -32000000D, 32000000D);
-			z = MathHelper.clamp(z, -32000000D, 32000000D);
-			teleport(handler, sender, player, null, x, y, z, player.yRot, player.xRot, null);
-			return true;
-		}
-		
-		return false;
-	}
-	
-	public double parseDouble(String str) {
-		try {
-			return Double.parseDouble(str);
-		}catch (Exception e) {
-			throw new CommandError("Not a number: \""+str+"\"");
-		}
-	}
-	
-	public Player getPlayer(CommandHandler handler, String name) {
-		Player player = handler.getPlayer(name);
-		if(player == null) throw new CommandError("Player not found: "+name);
-		return player;
-	}
-	
-	@Override
-	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-		boolean server = handler instanceof ServerCommandHandler;
-		boolean sentByPlayer = sender instanceof PlayerCommandSender;
-		
-		if(server) sender.sendMessage("/tp <FromPlayer> <ToPlayer>");
-		if(sentByPlayer && server) sender.sendMessage("/tp <ToPlayer>");
-		if(server) sender.sendMessage("/tp <Player> <x> <y> <z>");
-		if(sentByPlayer) sender.sendMessage("/tp <x> <y> <z>");
-	}
+public class TeleportCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("teleport")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, DoubleCoordinates>argument("position", Vec3ArgumentType.vec3d())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            DoubleCoordinates targetCoordinates = c.getArgument("position", DoubleCoordinates.class);
 
-	@Override
-	public boolean opRequired(String[] args) {
-		return true;
-	}
-	
-	public static void teleport(CommandHandler handler, CommandSender sender, Player p1, Integer dimension, double x, double y, double z, double yaw, double pitch, Player p2) {
-		if(p1 instanceof ServerPlayer) {
-			
-			ServerPlayer p1MP = (ServerPlayer) p1;
-			if(dimension != null && p1MP.dimension != dimension && handler instanceof ServerCommandHandler) {
-				ServerCommandHandler serverCommandHandler = (ServerCommandHandler) handler;
-				serverCommandHandler.minecraftServer.playerList.sendPlayerToOtherDimension(p1MP, dimension, false);
-			}
-			p1MP.playerNetServerHandler.teleportAndRotate(x, y, z, p1MP.yRot, p1MP.xRot);
-		}else {
-			p1.absMoveTo(x, y, z, p1.yRot, p1.xRot);
-		}
-		
-		if(p2 != null) {
-			handler.sendCommandFeedback(sender, "Teleporting " + p1.getDisplayName() + TextFormatting.WHITE + " to " + p2.getDisplayName());
-		}else {
-			handler.sendCommandFeedback(sender, "Teleporting " + p1.getDisplayName() + TextFormatting.WHITE + " to x: " + floor10(x) + " y: "+floor10(y) + " z: "+floor10(z));
-		}
-	}
-	
-	public static void teleport(CommandHandler handler, CommandSender sender, Player p1, Player p2) {
-		teleport(handler, sender, p1, p2.dimension, p2.x, p2.y, p2.z, p2.yRot, p2.xRot, p2);
-	}
-	
-	public static double floor10(double a) {
-		return ((int)(a * 10)) / 10.0;
-	}
+                            if (source.getSender() != null) {
+                                source.getSender().moveTo(targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source), source.getSender().yRot, source.getSender().xRot);
+                                source.sendTranslatableMessage("command.commands.teleport.location.success_single_entity", source.getSender().getDisplayName(), targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source));
+                            } else {
+                                throw CommandExceptions.notInWorld().create();
+                            }
 
+                            return Command.SINGLE_SUCCESS;
+                        }))
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("entity", EntityArgumentType.entities())
+                        .then(RequiredArgumentBuilder.<CommandSource, DoubleCoordinates>argument("position", Vec3ArgumentType.vec3d())
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    EntitySelector entitySelector = c.getArgument("entity", EntitySelector.class);
+                                    DoubleCoordinates targetCoordinates = c.getArgument("position", DoubleCoordinates.class);
+
+                                    List<? extends Entity> entities = entitySelector.get(source);
+                                    for (Entity entity : entities) {
+                                        entity.moveTo(targetCoordinates.getX(source), targetCoordinates.getY(source, true), targetCoordinates.getZ(source), entity.yRot, entity.xRot);
+                                    }
+
+                                    double x = targetCoordinates.getX(source);
+                                    double y = targetCoordinates.getY(source, true);
+                                    double z = targetCoordinates.getZ(source);
+
+                                    if (entities.size() == 1) source.sendTranslatableMessage("command.commands.teleport.location.success_single_entity", CommandHelper.getEntityName(entities.get(0)), x, y, z);
+                                    else if (entities.size() > 1) source.sendTranslatableMessage("command.commands.teleport.location.success_multiple_entities", entities.size(), x, y, z);
+
+                                    return Command.SINGLE_SUCCESS;
+                                }))
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.entity())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("entity", EntitySelector.class);
+                            EntitySelector targetEntitySelector = c.getArgument("target", EntitySelector.class);
+                            Entity targetEntity = targetEntitySelector.get(c.getSource()).get(0);
+
+                            List<? extends Entity> entities = entitySelector.get(c.getSource());
+                            for (Entity entity : entities) {
+                                entity.moveTo(targetEntity.x, targetEntity.y - targetEntity.heightOffset, targetEntity.z, entity.yRot, entity.xRot);
+                            }
+
+                            if (entities.size() == 1) source.sendTranslatableMessage("command.commands.teleport.entity.success_single_entity", CommandHelper.getEntityName(entities.get(0)), CommandHelper.getEntityName(targetEntity));
+                            else if (entities.size() > 1) source.sendTranslatableMessage("command.commands.teleport.entity.success_multiple_entities", entities.size(), CommandHelper.getEntityName(targetEntity));
+
+                            return Command.SINGLE_SUCCESS;
+                        }))));
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("tp")
+                .requires(CommandSource::hasAdmin)
+                .redirect(command));
+    }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/TellRawCommand.java b/src/main/java/net/minecraft/core/net/command/commands/TellRawCommand.java
new file mode 100644
index 000000000..d37e09736
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/TellRawCommand.java
@@ -0,0 +1,36 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.StringArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+
+import java.util.List;
+
+public class TellRawCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("tellraw")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("targets", EntityArgumentType.players())
+                        .then(RequiredArgumentBuilder.<CommandSource, String>argument("message", StringArgumentType.greedyString())
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    EntitySelector entitySelector = c.getArgument("targets", EntitySelector.class);
+                                    String message = c.getArgument("message", String.class);
+
+                                    List<? extends Entity> players = entitySelector.get(source);
+
+                                    for (Entity player : players) {
+                                        source.sendMessage((Player) player, message);
+                                    }
+
+                                    return Command.SINGLE_SUCCESS;
+                                }))));
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/TestCommand.java b/src/main/java/net/minecraft/core/net/command/commands/TestCommand.java
new file mode 100644
index 000000000..5c3cf94ec
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/TestCommand.java
@@ -0,0 +1,26 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.AchievementArgumentType;
+
+@SuppressWarnings("unchecked")
+public class TestCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register((LiteralArgumentBuilder)(((LiteralArgumentBuilder)LiteralArgumentBuilder.literal("test"))
+                .then(((LiteralArgumentBuilder)LiteralArgumentBuilder.<CommandSource>literal("grant")
+                ).then(RequiredArgumentBuilder.argument("achievement", AchievementArgumentType.achievement())
+                        .then(RequiredArgumentBuilder.argument("achievement1", AchievementArgumentType.achievement())
+                                .then(RequiredArgumentBuilder.argument("achievement2", AchievementArgumentType.achievement())
+                                        .then(RequiredArgumentBuilder.argument("achievement3", AchievementArgumentType.achievement())
+                                                .then(RequiredArgumentBuilder.argument("achievement4", AchievementArgumentType.achievement())
+                                                        .then(RequiredArgumentBuilder.argument("achievement5", AchievementArgumentType.achievement())
+                                                                .executes(c -> {
+                                                                    ((CommandSource)c.getSource()).getSender().sendMessage("Command run!");
+                                                                    return Command.SINGLE_SUCCESS;
+                                                                }))))))))));
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/TestForCommand.java b/src/main/java/net/minecraft/core/net/command/commands/TestForCommand.java
new file mode 100644
index 000000000..ed9e35aca
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/TestForCommand.java
@@ -0,0 +1,87 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.BlockArgumentType;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.arguments.IntegerCoordinatesArgumentType;
+import net.minecraft.core.net.command.helpers.*;
+
+import java.util.List;
+
+public class TestForCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("testfor")
+                .requires(CommandSource::hasAdmin)
+                .then(LiteralArgumentBuilder.<CommandSource>literal("entity")
+                        .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("entities", EntityArgumentType.entities())
+                                .executes(c -> {
+                                    List<? extends Entity> entities = c.getArgument("entities", EntitySelector.class).get(c.getSource());
+                                    c.getSource().sendTranslatableMessage("command.commands.testfor.entity." + (entities.isEmpty() ? "none" : entities.size() == 1 ? "single" : "multiple"), entities.size());
+                                    return entities.size();
+                                })))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("block")
+                        .then(RequiredArgumentBuilder.<CommandSource, BlockInput>argument("block", BlockArgumentType.block())
+                                .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("second", IntegerCoordinatesArgumentType.intCoordinates())
+                                        .executes(c -> {
+                                            BlockInput block = c.getArgument("block", BlockInput.class);
+                                            IntegerCoordinates secondPos = c.getArgument("second", IntegerCoordinates.class);
+                                            CompoundTag blockInWorldCompoundTag = new CompoundTag();
+                                            BlockEntity blockEntity = c.getSource().getWorld().getBlockEntity(secondPos.getX(c.getSource()), secondPos.getY(c.getSource(), true), secondPos.getZ(c.getSource()));
+                                            if (blockEntity != null) blockEntity.writeToNBT(blockInWorldCompoundTag);
+                                            if (c.getSource().getWorld().getBlock(secondPos.getX(c.getSource()), secondPos.getY(c.getSource(), true), secondPos.getZ(c.getSource())) == block.getBlock()
+                                            && c.getSource().getWorld().getBlockMetadata(secondPos.getX(c.getSource()), secondPos.getY(c.getSource(), true), secondPos.getZ(c.getSource())) == block.getMetadata()
+                                            && (blockInWorldCompoundTag == block.getTag() || block.getTag().getValues().isEmpty())) {
+                                                c.getSource().sendTranslatableMessage("command.commands.testfor.block.success");
+                                                return Command.SINGLE_SUCCESS;
+                                            }
+                                            c.getSource().sendTranslatableMessage("command.commands.testfor.block.failure");
+                                            return 0;
+                                        })))
+                        .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("first", IntegerCoordinatesArgumentType.intCoordinates())
+                                .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("second", IntegerCoordinatesArgumentType.intCoordinates())
+                                        .executes(c -> {
+                                            IntegerCoordinates firstPos = c.getArgument("first", IntegerCoordinates.class);
+                                            IntegerCoordinates secondPos = c.getArgument("second", IntegerCoordinates.class);
+
+                                            Block firstBlock = c.getSource().getWorld().getBlock(firstPos.getX(c.getSource()), firstPos.getY(c.getSource(), true), firstPos.getZ(c.getSource()));
+                                            Block secondBlock = c.getSource().getWorld().getBlock(secondPos.getX(c.getSource()), secondPos.getY(c.getSource(), true), secondPos.getZ(c.getSource()));
+
+                                            if (firstBlock != secondBlock) {
+                                                c.getSource().sendTranslatableMessage("command.commands.testfor.block.failure");
+                                                return 0;
+                                            }
+
+                                            int firstMetadata = c.getSource().getWorld().getBlockMetadata(firstPos.getX(c.getSource()), firstPos.getY(c.getSource(), true), firstPos.getZ(c.getSource()));
+                                            int secondMetadata = c.getSource().getWorld().getBlockMetadata(secondPos.getX(c.getSource()), secondPos.getY(c.getSource(), true), secondPos.getZ(c.getSource()));
+
+                                            if (firstMetadata != secondMetadata) {
+                                                c.getSource().sendTranslatableMessage("command.commands.testfor.block.failure");
+                                                return 0;
+                                            }
+
+                                            CompoundTag firstTag = new CompoundTag();
+                                            BlockEntity firstBlockEntity = c.getSource().getWorld().getBlockEntity(firstPos.getX(c.getSource()), firstPos.getY(c.getSource(), true), firstPos.getZ(c.getSource()));
+                                            if (firstBlockEntity != null) firstBlockEntity.writeToNBT(firstTag);
+                                            CompoundTag secondTag = new CompoundTag();
+                                            BlockEntity secondBlockEntity = c.getSource().getWorld().getBlockEntity(secondPos.getX(c.getSource()), secondPos.getY(c.getSource(), true), secondPos.getZ(c.getSource()));
+                                            if (secondBlockEntity != null) secondBlockEntity.writeToNBT(secondTag);
+
+                                            if (!CommandHelper.blockEntitiesAreEqual(firstTag, secondTag)) {
+                                                c.getSource().sendTranslatableMessage("command.commands.testfor.block.failure");
+                                                return 0;
+                                            }
+
+                                            c.getSource().sendTranslatableMessage("command.commands.testfor.block.success");
+                                            return Command.SINGLE_SUCCESS;
+                                        })))));
+    }
+}
